#include "clean.h"

cleaning *allocclean(unsigned n){
	cleaning *clean=malloc(sizeof(cleaning));
	clean->n=n;
	clean->c=calloc(n,sizeof(unsigned*));
	clean->s=calloc(n,sizeof(unsigned));
	clean->smax=calloc(n,sizeof(unsigned));
	
	clean->nc=0;
	clean->mc=NCOMS;
	clean->size=malloc(clean->mc*sizeof(unsigned));
	clean->qual=malloc(clean->mc*sizeof(double));
	clean->times=malloc(clean->mc*sizeof(unsigned));
	clean->node=malloc(clean->mc*sizeof(unsigned));
	clean->com=malloc(clean->mc*sizeof(unsigned*));

	clean->tmp=calloc(clean->mc,sizeof(unsigned));
	clean->list=calloc(clean->mc,sizeof(unsigned));
	clean->nlist=0;

	clean->itc=0;
	clean->qualc=0;
	clean->difc=0;
	clean->selc=0;

	return clean;
}


void comsim(proximity* prox,cleaning *clean){
	double sim2;
	unsigned i,j,node,com;
	clean->sim=0;
	clean->isim=0;

	for (i=0;i<prox->size;i++){
		node=prox->scores[i].id;
		for (j=0;j<clean->s[node];j++){
			if (clean->tmp[clean->c[node][j]]==0){
				clean->list[clean->nlist++]=clean->c[node][j];
			}
			clean->tmp[clean->c[node][j]]++;
		}
	}

	for (i=0;i<clean->nlist;i++){
		com=clean->list[i];
		sim2=((double)(clean->tmp[com]))/(prox->size+clean->size[com]);
		if (sim2>=clean->sim){
			clean->sim=sim2;
			clean->isim=com;
		}
		clean->tmp[com]=0;
	}
	clean->nlist=0;
	clean->sim*=2;
}

void com2clean(proximity* prox,cleaning* clean){
	unsigned i,node;

	clean->itc++;
	if (prox->slope<PMIN){
		return;
	}
	clean->qualc++;

	comsim(prox,clean);

	if (clean->sim<SIM){
		clean->difc++;
		if (clean->nc==clean->mc){
			clean->mc+=NCOMS;
			clean->size=realloc(clean->size,clean->mc*sizeof(unsigned));
			clean->qual=realloc(clean->qual,clean->mc*sizeof(double));
			clean->node=realloc(clean->times,clean->mc*sizeof(unsigned));
			clean->times=realloc(clean->times,clean->mc*sizeof(unsigned));
			clean->tmp=realloc(clean->tmp,clean->mc*sizeof(unsigned));
			clean->list=realloc(clean->list,clean->mc*sizeof(unsigned));
			clean->com=realloc(clean->com,clean->mc*sizeof(unsigned*));
			for (i=clean->mc-NCOMS;i<clean->mc;i++){
				clean->tmp[i]=0;
			}
		}
		clean->size[clean->nc]=prox->size;
		clean->qual[clean->nc]=prox->slope;
		clean->node[clean->nc]=prox->node;
		clean->times[clean->nc]=1;
		clean->com[clean->nc]=malloc(prox->size*sizeof(unsigned));
		for (i=0;i<prox->size;i++){
			node=prox->scores[i].id;
			clean->com[clean->nc][i]=node;
			if (clean->s[node]==clean->smax[node]){
				if (clean->s[node]==0){
					clean->c[node]=malloc(NCPN*sizeof(unsigned));
					clean->smax[node]=NCPN;
				}
				else {
					clean->smax[node]+=NCPN;
					clean->c[node]=realloc(clean->c[node],clean->smax[node]*sizeof(unsigned));
				}
			}
			clean->c[node][clean->s[node]++]=clean->nc;
		}
		clean->nc++;
		return;
	}

	clean->times[clean->isim]++;

	if (clean->times[clean->isim]==TIMES){
		clean->selc++;
	}
}

void printallcom(char* node_coms,char* com_nodes,char* info,cleaning* clean){
	unsigned i,j,k=0;
	FILE *file, *file2;
	unsigned* tmp=malloc(clean->nc*sizeof(unsigned));

	file=fopen(com_nodes,"w");
	file2=fopen(info,"w");
	for (i=0;i<clean->nc;i++) {
		if (clean->times[i]>=TIMES){
			fprintf(file,"%u",clean->com[i][0]);
			for (j=1;j<clean->size[i];j++) {
				fprintf(file," %u",clean->com[i][j]);
			}
			fprintf(file,"\n");
			fprintf(file2,"%u %u %u %le\n",clean->size[i],clean->node[i],clean->times[i],clean->qual[i]);
			tmp[i]=k++;
		}
	}
	fclose(file);
	fclose(file2);

	file=fopen(node_coms,"w");
	for (i=0;i<clean->n;i++) {
		for (j=0;j<clean->s[i];j++) {
			if (clean->times[clean->c[i][j]]>=TIMES){
				fprintf(file,"%u",tmp[clean->c[i][j]]);
				break;
		 	}
		}
		for (k=j+1;k<clean->s[i];k++) {
			if (clean->times[clean->c[i][k]]>=TIMES){
				fprintf(file," %u",tmp[clean->c[i][k]]);
		 	}
		}
		fprintf(file,"\n");
	}
	fclose(file);
	free(tmp);
}

void printprogress(cleaning* clean){
	if ((((clean->n>100000) && ((clean->itc*5000)/clean->n != ((clean->itc-1)*5000)/clean->n))) || (clean->n==clean->itc)){
		printf("\nProgress: %.2f percent\n",clean->itc*100./clean->n);
		printf("Number of proximity computation: %u\n",clean->itc);
		printf("Number of high slope: %u\n",clean->qualc);
		printf("Number of different communities found: %u\n",clean->difc);
		printf("Number of communities found: %u\n",clean->selc);
	}
}

