#ifndef CLEAN_H
#define CLEAN_H

#include <stdio.h>
#include <stdlib.h>
#include "param.h"
#include "proximity.h"

typedef struct {
	unsigned n;//number of nodes
	unsigned **c;//c[i]=communities containing node i.
	unsigned *s;//s[i]=number of communities containing node i.
	unsigned *smax;//smax[i]=max number of communities

	unsigned nc;//number of communities
	unsigned mc;//max number of communities
	unsigned *size;//size[i]=size of the community i
	double *qual;//qual[i]=quality of the community i
	unsigned *times;//times[i]=number of times the community i was found
	unsigned *node;//node[i]=representative of community i
	unsigned **com;//com[i]=nodes in community i

	unsigned *tmp;//tmp[i] number of nodes shared by the current community and community i
	unsigned *list;//list of the community sharing at least one node with the current community
	unsigned nlist;//length of list

	double sim;//similarity of the current community to the most similar community already in the cleaning datastructure
	unsigned isim;//id of the most similar community

	unsigned itc;//total number of communities
	unsigned qualc;//number of communities of good quality
	unsigned difc;//number of diferent communities of good quality
	unsigned selc;//number of diferent communities of good quality found more than NTIME
} cleaning;

//allocating memory for the cleaning datastructure
cleaning *allocclean(unsigned);

//compute the similarity (F-score) of the current community to the most similar already found community
void comsim(proximity*,cleaning*);

//add the found community to the cleaning datastructure
void com2clean(proximity*,cleaning*);

//printing all the communities in the files
void printallcoms(char*,char*,char*,cleaning*);

//printing in terminal the progress
void printprogress(cleaning*);

#endif
