#include "graph.h"


unsigned max3(unsigned a,unsigned b,unsigned c){
	a=(a>b) ? a : b;
	return (a>c) ? a : c;
}

sparse* edgelist2sparse(char* edgelist){
	unsigned i, e=0, e1=NLINKS, n=0;
	unsigned *a1=malloc(e1*sizeof(unsigned)), *a2=malloc(e1*sizeof(unsigned));
	unsigned *deg, *t;
	sparse *mat=malloc(sizeof(sparse));
	FILE *file;

	printf("Reading unweighted edgelist from file %s\n",edgelist);
	file=fopen(edgelist,"r");
	while (fscanf(file,"%u %u", &a1[e], &a2[e])==2) {
		n=max3(n,a1[e],a2[e]);
		if (e++==e1) {
			e1+=NLINKS;
			a1=realloc(a1,e1*sizeof(unsigned));
			a2=realloc(a2,e1*sizeof(unsigned));
		}
	}
	fclose(file);
	n++;
	
	mat->dim=n;

	deg=calloc(n,sizeof(unsigned));
	for (i=0;i<e;i++) {
		deg[a1[i]]++;
		deg[a2[i]]++;
	}

	mat->degcum=malloc((n+1)*sizeof(unsigned));
	mat->degcum[0]=0;
	for (i=1;i<n+1;i++) {
		mat->degcum[i]=mat->degcum[i-1]+deg[i-1];
	}

	free(deg);

	t=calloc(n,sizeof(unsigned));

	mat->neigh=malloc(2*e*sizeof(unsigned));

	for (i=0;i<e;i++) {
		mat->neigh[ mat->degcum[a1[i]] + t[ a1[i] ]++ ]=a2[i];
		mat->neigh[ mat->degcum[a2[i]] + t[ a2[i] ]++ ]=a1[i];
	}

	free(a1),free(a2),free(t);

	return mat;
}

void printgraphinfo(sparse* mat){
		printf("\nGraph loaded\n");
		printf("Number of nodes: %u\n",mat->dim);
		printf("Number of edges: %u\n",mat->degcum[mat->dim]/2);
}


