#include <stdlib.h>
#include <time.h>
#include <math.h>

#include "graph.h"
#include "proximity.h"
#include "clean.h"
#include "param.h"

int main(int argc,char** argv){
	unsigned i;
	sparse *mat;
	proximity *prox;
	cleaning *clean;

	mat=edgelist2sparse(argv[1]);
	printgraphinfo(mat);

	//allocating the proximity data structure
	prox=allocprox(mat);

	//allocating the cleaning data structure
	clean=allocclean(mat->dim);

	for (i=0;i < mat->dim;i++) {
		computeprox(mat,prox,i); //computation of ppr with the push method
		mkcom(prox); //compute highest slope and make the community
		com2clean(prox,clean); //add the community to the cleaning datastructure
		printprogress(clean);//print the progress
	}

	printallcom("node_coms","com_nodes","info",clean);

	return 0;
}

