#ifndef FUNCQUAL_H
#define FUNCQUAL_H

#include <stdbool.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "graph.h"
#include "param.h"

// FIFO queue:
typedef struct {
	int s;//number of nodes in the queue
	int in;//pointer to insertion
	int out;//pointer to extraction
	unsigned *tab;//nodes in the queue
	bool *intab;//intab[i]=1 iff i is in tab
} fifo;

//to qsort
typedef struct {
	unsigned id;	//id of the node
	double val;	//score of the node
} idval;

typedef struct {
	unsigned n;//number of nodes
	unsigned node;//node of interest
	idval* scores;//scores of the nodes
	unsigned ns;//number of nodes with nonzero scores
	unsigned size;//size of the found community
	double slope;//maximum slope
} proximity;

fifo* allocfifo(unsigned);

//allocating the proximity datastructure for the optimisation
proximity *allocprox(sparse*);

void empty(proximity*);

// compute the proximities using the push method
void computeprox(sparse*,proximity*,unsigned);

static int compare (void const *, void const *);

void mkscores(proximity*);

void mkcom(proximity*);

//printing the community in the folder "test"
//not used (just used to test)
void printcom(proximity*);

#endif
